import { PointModel } from "../../point-component/models/point-model";
import { ELEMENTS_CLASS } from "../../../core/enums/elements-class-enum";

export class IntersectionModel extends PointModel {
  constructor(posX, posY, label, r, s, visible) {
    super(posX, posY, label);
    this.r = r;
    this.s = s;
    super.setClass(ELEMENTS_CLASS.INTERSECTION_POINT);
    this.visible = visible;
  }

  update(aggregator, event) {
    const intersections = this.r.getIntersection(this.s);
    for (let index = 0; index < intersections.length; index++) {
      const intersection = intersections[index];
      this.posX = parseFloat(intersection.posX.toFixed(2));
      this.posY = parseFloat(intersection.posY.toFixed(2));
      if (!this.r.insideSegment(this.posX, this.posY)) {
        this.posX = Number.MAX_SAFE_INTEGER;
        this.posY = Number.MAX_SAFE_INTEGER;
        this.visible = false;
        return;
      }
      if (!this.s.insideSegment(this.posX, this.posY)) {
        this.posX = Number.MAX_SAFE_INTEGER;
        this.posY = Number.MAX_SAFE_INTEGER;
        this.visible = false;
        return;
      }
    }
    this.visible = true;
  }
}
